<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: ActionChain.class.php,v 1.4 2006/02/11 19:18:22 kunit Exp $
 */

require_once 'core/ErrorList.class.php';

/**
 * Action륯饹
 *
 * Υ饹ȤäActionForwardб
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class ActionChain
{
    /**
     * @var Actionݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_list;

    /**
     * @var ErrorListݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_errorList;

    /**
     * @var Actionΰ֤ݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_position;

    /**
     * @var ߼¹ԤƤActionΰ֤ݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_index;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function ActionChain()
    {
        $this->_list      = array();
        $this->_errorList = array();
        $this->_position  = array();
        $this->_index     = 0;
    }

    /**
     * Action饹򥻥å
     *
     * @param   string  $name   ActionΥ饹̾
     * @access  public
     * @since   3.0.0
     */
    function add($name)
    {
        $log =& LogFactory::getLog();

        //
        // ꤵƤʤäǥեȤActionڤؤ
        //
        //
        if ($name == "") {
            $name = DEFAULT_ACTION;
        }

        //
        // ActionΥ饹̾äǥեȤActionڤؤ
        //
        if (!preg_match("/^[0-9a-zA-Z_]+$/", $name)) {
            $log->info("ActionꤵƤޤ(${name})", "ActionChain#add");
            $name = DEFAULT_ACTION;
        }

        //
        // ե뤬¸ߤƤʤХǥեȤActionڤؤ
        //
        list ($className, $filename) = ActionChain::makeNames($name, true);

        if (!$className) {
            $log->info("¸ߤƤʤActionꤵƤޤ(${name})", "ActionChain#add");
            $name = DEFAULT_ACTION;
            list ($className, $filename) = ActionChain::makeNames($name, true);
        }

        //
        // Ʊ̾ActionɲäƤ鲿⤷ʤ
        //
        if (isset($this->_list[$name]) && is_object($this->_list[$name])) {
            $log->info("ActionϴϿƤޤ(${name})", "ActionChain#add");
            return true;
        }

        //
        // ֥Ȥ˼ԤƤ饨顼
        //
        include_once($filename);

        $action =& new $className();

        if (!is_object($action)) {
            $log->error("Action˼Ԥޤ(${name})", "ActionChain#add");
            return false;
        }

        $this->_list[$name]      =& $action;
        $this->_errorList[$name] =& new ErrorList();
        $this->_position[]       =  $name;

        return true;
    }

    /**
     * ActionΥ饹̾ӥեѥֵѤ
     *
     * @param   string  $name   Action̾
     * @param   boolean $check  ե¸ߥå򤹤뤫ɤ
     * @return  array   ActionΥ饹̾ȥեѥ
     * @access  public
     * @since   3.0.0
     */
    function makeNames($name, $check = false)
    {
        $pathList   = explode("_", $name);
        $ucPathList = array_map('ucfirst', $pathList);

        $basename = ucfirst($pathList[count($pathList) - 1]);

        $actionPath = join("/", $pathList);
        $className  = join("_", $ucPathList);
        $filename   = MODULE_DIR . "/${actionPath}/${basename}.class.php";

        if (!$check) {
            return array($className, $filename);
        }

        if (!@file_exists($filename)) {
            $filename = MODULE_DIR . "/${actionPath}/${className}.class.php";
            if (!@file_exists($filename)) {
                $className = null;
                $filename  = null;
            }
        }

        return array($className, $filename);
    }

    /**
     * ActionChain򥯥ꥢ
     *
     * @access  public
     * @since   3.0.0
     */
    function clear()
    {
        $this->_list      = array();
        $this->_errorList = array();
        $this->_position  = array();
        $this->_index     = 0;
    }

    /**
     * ActionChainĹֵ
     *
     * @return  integer ActionChainĹ
     * @access  public
     * @since   3.0.0
     */
    function getSize()
    {
        return count($this->_list);
    }

    /**
     * ActionChain򼡤˿ʤ뤳ȤǤ뤫ֵ
     *
     * @return  boolean ˿ʤ뤫ɤ
     * @access  public
     * @since   3.0.0
     */
    function hasNext()
    {
        return ($this->_index < $this->getSize());
    }

    /**
     * ActionChain򼡤˿ʤ
     *
     * @access  public
     * @since   3.0.0
     */
    function next()
    {
        if ($this->_index < $this->getSize()) {
            $this->_index++;
        }
    }

    /**
     * ߤActionֵ̾
     *
     * @return  string  Action̾
     * @access  public
     * @since   3.0.0
     */
    function getCurActionName()
    {
        if (isset($this->_position[$this->_index])) {
            return $this->_position[$this->_index];
        }
    }

    /**
     * ꤵ줿̾Actionֵ
     *
     * @param   string  $name   Action̾
     * @return  Object  ActionΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getActionByName($name)
    {
        $log =& LogFactory::getLog();

        if ($name == "") {
            $log->warn("Ǥ", "ActionChain#getActionByName");
            return false;
        }

        if (!isset($this->_list[$name]) || !is_object($this->_list[$name])) {
            $log->error("ꤵ줿ActionϿƤޤ(${name})", "ActionChain#getActionByName");
            return false;
        }

        $action =& $this->_list[$name];

        if (!is_object($action)) {
            $log->error("Actionμ˼Ԥޤ(${name})", "ActionChain#getCurAction");
            return false;
        }

        return $action;
    }

    /**
     * ꥹȤƬActionΥ󥹥󥹤ֵ
     *
     * @return  Object  ActionΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getCurAction()
    {
        $name = $this->getCurActionName();
        return $this->getActionByName($name);
    }

    /**
     * ꤵ줿̾ActionФErrorListֵ
     *
     * @param   string  $name   Action̾
     * @return  Object  ErrorListΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getErrorListByName($name)
    {
        if (isset($this->_errorList[$name])) {
            return $this->_errorList[$name];
        }
    }

    /**
     * ꥹȤƬActionФErrorListΥ󥹥󥹤ֵ
     *
     * @return  Object  ErrorListΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getCurErrorList()
    {
        $name = $this->getCurActionName();
        return $this->getErrorListByName($name);
    }

    /**
     * Action¹
     *
     * @return  string  ¹ԤActionֵ
     * @access  public
     * @since   3.0.0
     */
    function execute()
    {
        $log =& LogFactory::getLog();

        if ($this->getSize() < 1) {
            $log->error("ActionɲäƤޤ", "ActionChain#execute");
            return false;
        }

        $action =& $this->getCurAction();

        if (!is_object($action)) {
            $log->error("Actionμ˼Ԥޤ(${name})", "ActionChain#execute");
            return false;
        }

        return $action->execute();
    }

    /**
     * Actionɲ
     *
     * Ѥ䤹褦˥饹᥽åɤ
     *
     * @param   string  $name   ActionΥ饹̾
     * @access  public
     * @since   3.0.0
     */
    function forward($name)
    {
        $container =& DIContainerFactory::getContainer();
        $actionChain =& $container->getComponent("ActionChain");
        return $actionChain->add($name);
    }
}
?>
