<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: ConfigUtils.class.php,v 1.6 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * եƤݻ
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class ConfigUtils
{
    /**
     * @var ƥͤݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_config;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function ConfigUtils()
    {
        $this->_config = array();
    }

    /**
     * եɤ߹
     *
     * @access  public
     * @since   3.0.0
     */
    function execute()
    {
        $curPath = "/";

        ConfigUtils::_getConfig($curPath);

        $container =& DIContainerFactory::getContainer();
        $actionChain =& $container->getComponent("ActionChain");
        $pathList = explode("_", $actionChain->getCurActionName());

        if (DEBUG_MODE) {
            $this->_setConfig('Debug', array());
        }

        $count = 0;

        foreach ($pathList as $path) {
            $curPath .= "${path}/";
            $count++;
            ConfigUtils::_getConfig($curPath, ($count == count($pathList)));
        }
    }

    /**
     * ꤵ줿ǥ쥯ȥեɤ߹
     *
     * @param   string  $path   եɤѥ
     * @param   boolean $last   ǲؤãɤ
     * @access  private
     * @since   3.0.0
     */
    function _getConfig($path, $level = false)
    {
        $filename = MODULE_DIR . $path . CONFIG_FILE;

        if (!@file_exists($filename)) {
            return;
        }

        $config = parse_ini_file($filename, TRUE);

        //
        // ActionƱ٥뤫ɤǽڤʬ
        //
        if ($level != true) {
            //
            // GlobalFilter˵ҤƤFilter򥻥åȤ
            //
            if (isset($config["GlobalFilter"]) &&
                is_array($config["GlobalFilter"])) {
                foreach ($config["GlobalFilter"] as $key => $value) {
                    if (!preg_match("/Action$/", $key)) {
                        $this->_setConfig($key, $config);
                    }
                }
            }
        } else {
            //
            // Actionϼ¹ԤΤǥס뤷Ƥơ
            // ʳΤΤ򥻥åȤ
            //
            $actionKey = "";

            foreach ($config as $key => $value) {
                if (preg_match("/Action$/", $key)) {
                    $actionKey = $key;
                } else if (!preg_match("/GlobalFilter$/", $key)) {
                    $this->_setConfig($key, $config);
                }
            }

            //
            // ActionΤߤϥ󤬤ʤƤǥեȤAction
            //
            if ($actionKey) {
                $this->_setConfig($actionKey, $config);
            } else {
                $this->_setConfig("Action", $config);
            }
        }
    }

    /**
     * 򥯥ꥢ
     *
     * @access  public
     * @since   3.0.0
     */
    function clear()
    {
        $this->_config = array();
    }

    /**
     * ꤵ줿
     *
     * @param   string  $section    ̾
     * @param   array   $config     
     * @access  private
     * @since   3.0.0
     */
    function _setConfig($section, $config)
    {
        if(!isset($this->_config[$section])) {
            $this->_config[$section] = array();
        }

        if (isset($config[$section]) && is_array($config[$section])) {
            foreach ($config[$section] as $key => $value) {
                if (CONFIG_CODE != INTERNAL_CODE) {
                    $value = mb_convert_encoding($value, INTERNAL_CODE, CONFIG_CODE);
                }
                $this->_config[$section][$key] = $value;
            }
        }
    }

    /**
     * ֵ
     *
     * @return  array   
     * @access  public
     * @since   3.0.0
     */
    function &getConfig()
    {
        return $this->_config;
    }

    /**
     * ꤵ줿ֵ
     *
     * @param   string  $section    ̾
     * @return  array   
     * @access  public
     * @since   3.0.0
     */
    function &getSectionConfig($section)
    {
        if (isset($this->_config[$section])) {
            return $this->_config[$section];
        }
    }
}
?>
