<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Controller.class.php,v 1.4 2006/02/11 19:18:22 kunit Exp $
 */

require_once 'core/LogFactory.class.php';
require_once 'core/DIContainerFactory.class.php';

/**
 * ե졼ư礹륯饹
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class Controller
{
    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function Controller()
    {
    }

    /**
     * ե졼ư
     *
     * @access  public
     * @since   3.0.0
     */
    function execute()
    {
        $log =& LogFactory::getLog();

        //
        // DIContainer
        //
        $container =& Controller::_createDIContainer();

        if (!is_object($container)) {
            $log->fatal("DIContainer˼Ԥޤ", "Controller#execute");
            return;
        }

        //
        // ꥯȥѥ᡼¹ԤAction
        //
        $request =& $container->getComponent("Request");
        $request->dispatchAction();
        $actionName = $request->getParameter(ACTION_KEY);

        //
        // ActionActionChain˥å
        //
        $actionChain =& $container->getComponent("ActionChain");
        $actionChain->add($actionName);

        //
        // ¹Ԥ٤Action¤귫֤
        //
        while ($actionChain->hasNext()) {
            //
            // եɤ߹
            //
            $configUtils =& $container->getComponent("ConfigUtils");
            $configUtils->execute();

            //
            // ե򸵤FilterChainȤΩƤơ¹
            //
            $filterChain =& $container->getComponent("FilterChain");
            $filterChain->build($configUtils);
            $filterChain->execute();
            $filterChain->clear();

            //
            // ӼAction
            //
            $configUtils->clear();

            $actionChain->next();
        }
    }

    /**
     * DIContainer
     *
     * @access  public
     * @since   3.0.0
     */
    function &_createDIContainer()
    {
        $log =& LogFactory::getLog();

        if (!@file_exists(BASE_INI)) {
            $log->fatal("ե뤬¸ߤޤ", "Controller#_createDIContainer");
            return;
        }

        $config = parse_ini_file(BASE_INI, TRUE);

        if (count($config) < 1) {
            $log->fatal("ե뤬Ǥ", "Controller#_createDIContainer");
            return;
        }

        $container =& DIContainerFactory::getContainer();

        foreach ($config as $key => $value) {
            if (isset($config[$key]["name"])) {
                $className = $config[$key]["name"];
            }
            if (isset($config[$key]["path"])) {
                $filename = $config[$key]["path"];
            }

            if (!$className || !$filename) {
                $log->fatal("ե뤬Ǥ", "Controller#_createDIContainer");
                return;
            }

            include_once($filename);

            $instance =& new $className();

            if (!is_object($instance)) {
                $log->fatal("󥹥󥹤˼Ԥޤ($className)", "Controller#_createDIContainer");
                return;
            }

            $container->register($instance, $key);
        }

        return $container;
    }
}
?>
