<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: ErrorList.class.php,v 1.5 2006/02/12 14:28:42 kunit Exp $
 */

/**
 * ϥեɤΥ顼ݻ륯饹
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class ErrorList
{
    /**
     * @var 顼μݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_type;

    /**
     * @var 顼ʸݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_list;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function ErrorList()
    {
        $this->_type = NULL;
        $this->_list = array();
    }

    /**
     * 顼ʸɲ
     *
     * @param   string  $key    顼ȯ
     * @param   string  $str    顼ʸ
     * @access  public
     * @since   3.0.0
     */
    function add($key, $value)
    {
        if (!isset($this->_list[$key])) {
            $this->_list[$key] = array();
        }
        $this->_list[$key][] = $value;
    }

    /**
     * ErrorList򥯥ꥢ
     *
     * @access  public
     * @since   3.0.0
     */
    function clear()
    {
        $this->_list = array();
    }

    /**
     * ߥ顼뤫ɤֵ
     *
     * @return  boolean 顼뤫ɤο(true/false)
     * @access  public
     * @since   3.0.0
     */
    function isExists()
    {
        return (count($this->_list) > 0);
    }

    /**
     * 顼μֵ
     *
     * @return  string  顼μ
     * @access  public
     * @since   3.0.0
     */
    function getType()
    {
        return $this->_type;
    }

    /**
     * 顼μ򥻥å
     *
     * @param   string  $type   顼μ
     * @access  public
     * @since   3.0.0
     */
    function setType($type)
    {
        $this->_type = $type;
    }

    /**
     * ꤵ줿ܤΥ顼ֵ
     *
     * Smarty°ϢϤ뤿 $params["key"] Ǽ
     *
     * @param   string  $params 顼ȯ
     * @return  array   顼ʸ
     * @access  public
     * @since   3.0.0
     */
    function getMessage($params)
    {
        $key = $params["key"];

        $container =& DIContainerFactory::getContainer();
        $actionChain =& $container->getComponent("ActionChain");
        $errorList =& $actionChain->getCurErrorList();

        if (isset($errorList->_list[$key])) {
            return $this->_list[$key];
        } else {
            return array();
        }
    }

    /**
     * ϿƤ륨顼ʸֵ
     *
     * @return  array   顼ʸ
     * @access  public
     * @since   3.0.0
     */
    function getMessages()
    {
        $container =& DIContainerFactory::getContainer();
        $actionChain =& $container->getComponent("ActionChain");
        $errorList =& $actionChain->getCurErrorList();

        $messages = array();
        foreach ($errorList->_list as $key => $value) {
            $messages = array_merge($messages, $value);
        }
        return $messages;
    }
}
?>
