<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      KeyPoint
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: FileUpload.class.php,v 1.6 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * FileUploadϢνԤʣåץбǡ
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      KeyPoint
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class FileUpload
{
    /**
     * @var եǻꤷե̾ݻ
     *
     * @access  private
     * @since   3.1.0
     */
    var $_name;
    
    /**
     * @var եưΥեΥ⡼ɤݻ
     *
     * @access  private
     * @since   3.1.0
     */
    var $_filemode;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.1.0
     */
    function FileUpload()
    {
        $this->_name     = "";   //ե̾˳Ǽ
        $this->_filemode = 0644;
    }

    /**
     * եǻꤷեֵ̾
     *
     * @return  string  ե̾
     * @access  public
     * @since   3.1.0
     */
    function getName()
    {
        return $this->_name;
    }
    
    /**
     * եǻꤷե̾򥻥å
     *
     * @param   string  $name   ե̾
     * @access  public
     * @since   3.1.0
     */
    function setName($name)
    {
        $this->_name = $name;
    }
    
    /**
     * եưΥեΥ⡼ɤֵ
     *
     * @return  integer եΥ⡼
     * @access  public
     * @since   3.1.0
     */
    function getFilemode()
    {
        return $this->_filemode;
    }
    
    /**
     * եưΥեΥ⡼ɤ򥻥å
     *
     * @param   integer $filemode   եΥ⡼
     * @access  public
     * @since   3.1.0
     */
    function setFilemode($filemode)
    {
        $this->_filemode = octdec($filemode);
    }

    /**
     * åץɤ줿ֵ
     *
     * @return  integer åץɤ줿
     * @access  public
     * @since   3.1.0
     */
    function count() {
        $name = $this->getName();
        if (is_array($_FILES[$name]["name"])) {
            return count($_FILES[$name]["name"]);
        } else {
            return 1;
        }
    }
    
    /**
     * 饤ȥޥθΥեֵ̾
     *
     * @return  array   饤ȥޥθΥե̾
     * @access  public
     * @since   3.1.0
     */
    function getOriginalName()
    {
        $original_name = array();
        //֤
        $name = $this->getName();
        if (($name != "") && isset($_FILES[$name])) {
            if (is_array($_FILES[$name]["name"])) {
                foreach ($_FILES[$name]["name"] as $key => $value) {
                    $original_name[$key] = $value;
                }
            }else if (isset($_FILES[$name]["name"])){
                $original_name[0] = $_FILES[$name]["name"];
            }
        }
        return $original_name;
    }
    
    /**
     * եMIMEֵ
     *
     * @return  array   եMIME
     * @access  public
     * @since   3.1.0
     */
    function getMimeType()
    {
        $mime_type = array();
        //֤
        $name = $this->getName();
        if (($name != "") && isset($_FILES[$name])) {
            if (is_array($_FILES[$name]["type"])) {
                foreach ($_FILES[$name]["type"] as $key => $value) {
                    $mime_type[$key] = $value;
                }
            }else if (isset($_FILES[$name]["type"])){
                $mime_type[0] = $_FILES[$name]["type"];
            }
        }
        return $mime_type;
    }
    
    /**
     * åץɤ줿եΥХñ̤Υֵ
     *
     * @return  array   եΥ
     * @access  public
     * @since   3.1.0
     */
    function getFilesize()
    {
        $filesize = array();
        //֤
        $name = $this->getName();
        if (($name != "") && isset($_FILES[$name])) {
            if (is_array($_FILES[$name]["size"])) {
                foreach ($_FILES[$name]["size"] as $key => $value) {
                    $filesize[$key] = $value;
                }
            }else if (isset($_FILES[$name]["size"])){
                $filesize[0] = $_FILES[$name]["size"];
            }
        }
        return $filesize;
    }
    
    /**
     * ƥݥեֵ̾
     *
     * @return  array   ƥݥե̾
     * @access  public
     * @since   3.1.0
     */
    function getTmpName()
    {
        $tmp_name = array();
        //֤
        $name = $this->getName();
        if (($name != "") && isset($_FILES[$name])) {
            if (is_array($_FILES[$name]["tmp_name"])) {
                foreach ($_FILES[$name]["tmp_name"] as $key => $value) {
                    $tmp_name[$key] = $value;
                }
            }else if (isset($_FILES[$name]["tmp_name"])){
                $tmp_name[0] = $_FILES[$name]["tmp_name"];
            }
        }
        return $tmp_name;
    }
    
    /**
     * ե륢åץɤ˴ؤ륨顼ɤֵ
     *
     * @return  array   ե륢åץɤ˴ؤ륨顼ɤ
     * @access  public
     * @since   3.1.0
     */
    function getError()
    {
        $error_list = array();
        //֤
        $name = $this->getName();
        if (($name != "") && isset($_FILES[$name])) {
            if (is_array($_FILES[$name]["error"])) {
                foreach ($_FILES[$name]["error"] as $key => $value) {
                    $error_list[$key] = $value;
                }
            }else if (isset($_FILES[$name]["error"])){
                $error_list[0] = $_FILES[$name]["error"];
            }
        }
        return $error_list;
    }
    
    /**
     * ꤵ줿MIMEˤʤäƤ뤫
     *
     * @param   array    $type  MIME
     * @return  array[boolean]  ꤵ줿MIMEˤʤäƤ뤫
     * @access  public
     * @since   3.1.0
     */
    function checkMimeType($type_list)
    {
        $mime_type_check = array();
        $mime_type = $this->getMimeType();
        if (count($mime_type) > 0) {
            foreach ($mime_type as $key => $val) {
                if (isset($type_list[$key])) {
                    $type = $type_list[$key];
                } else if (isset($type_list["default"])){
                    $type = $type_list["default"];
                } else {
                    $type = "";
                }
                if ($type == "" || in_array($val,$type)  ) {
                    $mime_type_check[$key] = true;
                }else {
                    $mime_type_check[$key] = false;
                }
            }
        }
        return $mime_type_check;
    }
    
    /**
     * ե륵ꤵ줿ʲɤ
     *
     * @param   array   $size_list  Ȥʤե륵
     * @return  array[boolean]    ե륵ꤵ줿ʲɤ
     * @access  public
     * @since   3.1.0
     */
    function checkFilesize($size_list)
    {
        $filesize_check = array();
        $filesize = $this->getFilesize();
        if (count($filesize) > 0) {
            foreach ($filesize as $key => $val) {
                if (isset($size_list[$key])) {
                    $size = $size_list[$key];
                } else if (isset($size_list["default"])) {
                    $size = $size_list["default"];
                } else {
                    $size = "";
                }
                if ($size == "" || $val <= $size) {
                    $filesize_check[$key] = true;
                }else {
                    $filesize_check[$key] = false;
                }
            }
        }
        return $filesize_check;
    }

    /**
     * ꤵ줿ѥإեư(one file)
     *
     * @param   strint  $name   ưΥեκֹ
     * @param   strint  $dest   ưΥե̾
     * @return  boolean ưɤ
     * @access  public
     * @since   3.1.0
     */
    function move($id,$dest)
    {
        $tmp_name = $this->getTmpName();
        if (isset($tmp_name[$id])) {
            if (move_uploaded_file($tmp_name[$id], $dest)) {
                chmod($dest, $this->getFilemode());
                return true;
            } else {
                return false;
            }
        } else {
            return false;
        }
    }
}
?>
