<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: LogFactory.class.php,v 1.4 2006/02/11 19:18:22 kunit Exp $
 */

require_once 'logger/Logger.interface.php';

/**
 * Logger뤿Υ饹
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class LogFactory
{
    /**
     * @var Loggerݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_list;

    /**
     * 󥹥ȥ饯
     *
     * LogFactory饹SingletonȤƻȤΤľnewƤϤʤ
     *
     * @access  private
     * @since   3.0.0
     */
    function LogFactory()
    {
        $this->_list = array();
    }

    /**
     * Request饹ͣΥ󥹥󥹤ֵ
     *
     * @return  Object  Request饹Υ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getInstance()
    {
        static $instance;
        if ($instance === NULL) {
            $instance = new LogFactory();
        }
        return $instance;
    }

    /**
     * Loggerֵ
     *
     * @param   string  $name   LoggerΥ饹̾
     * @return  Object  LoggerΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getLog($name = DEFAULT_LOGGER)
    {
        //
        // LoggerΥ饹̾äǥեȤLoggerڤؤ
        //
        if (!preg_match("/^[0-9a-zA-Z_]+$/", $name)) {
            $name = DEFAULT_LOGGER;
        }

        //
        // ˥åȤƤLoggerä餽򤽤Τޤֵ
        //
        $logFactory =& LogFactory::getInstance();

        if (isset($logFactory->_list[$name]) &&
            is_object($logFactory->_list[$name])) {
            return $logFactory->_list[$name];
        }

        //
        // ե뤬¸ߤƤʤХ顼ɽ
        //
        $className = "Logger_" . ucfirst($name);
        $filename = LOGGER_DIR . "/${className}.class.php";

        if (!@file_exists($filename)) {
            $error = "LoggerΥե̾Ǥ($filename)";
            trigger_error($error, E_USER_ERROR);
            exit;
        }

        //
        // ֥Ȥ˼ԤƤ饨顼
        //
        include_once($filename);

        $logger =& new $className();

        if (!is_object($logger)) {
            return false;
        }

        $logFactory->_list[$name] =& $logger;

        return $logger;
    }

    /**
     * LogFactory˥åȤƤLogger
     *
     * @access  public
     * @since   3.0.0
     */
    function clear()
    {
        $this->_list = array();
    }

    /**
     * ꤵ줿Logger
     *
     * @param   string  $name   Logger̾
     * @access  public
     * @since   3.0.0
     */
    function delete($name)
    {
        unset($this->_list[$name]);
    }
}
?>
