<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Request.class.php,v 1.5 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * POST/GETǼäͤǼ
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class Request
{
    /**
     * @var POT/GETǼäͤݻ
     *
     * @access  private
     * @since   3.0.0
     */
    var $_params;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function Request()
    {
        if ($_SERVER["REQUEST_METHOD"] == "POST") {
            $request = $_POST;
        } else {
            $request = $_GET;
        }

        if (get_magic_quotes_gpc()) {
            foreach ($request as $key => $value) {
                if (is_array($value)) {
                    foreach ($value as $subKey => $subValue) {
                        $value[$subKey] = stripslashes($subValue);
                    }
                } else {
                    $value = stripslashes($value);
                }

                $request[$key] = $value;
            }
        }

        if (!ini_get("mbstring.encoding_translation") &&
            (INPUT_CODE != INTERNAL_CODE)) {
             mb_convert_variables(INTERNAL_CODE, INPUT_CODE, $request);
        }

        $this->_params = $request;
    }

    /**
     * REQUEST_METHODֵͤ
     *
     * @return  string  REQUEST_METHOD
     * @access  public
     * @since   3.1.0
     */
    function getMethod()
    {
        return $_SERVER["REQUEST_METHOD"];
    }

    /**
     * POST/GETֵͤ
     *
     * @param   string  $key    ѥ᡼̾
     * @return  string  ѥ᡼
     * @access  public
     * @since   3.0.0
     */
    function getParameter($key)
    {
        if (isset($this->_params[$key])) {
            return $this->_params[$key];
        }
    }

    /**
     * POST/GETֵͤ(֥Ȥֵ)
     *
     * @param   string  $key    ѥ᡼̾
     * @return  Object  ѥ᡼
     * @access  public
     * @since   3.0.0
     */
    function &getParameterRef($key)
    {
        if (isset($this->_params[$key])) {
            return $this->_params[$key];
        }
    }

    /**
     * POST/GETͤ򥻥å
     *
     * @param   string  $key    ѥ᡼̾
     * @param   string  $value  ѥ᡼
     * @access  public
     * @since   3.0.0
     */
    function setParameter($key, $value)
    {
        $this->_params[$key] = $value;
    }

    /**
     * POST/GETͤ򥻥å(֥Ȥ򥻥å)
     *
     * @param   string  $key    ѥ᡼̾
     * @param   Object  $value  ѥ᡼
     * @access  public
     * @since   3.0.0
     */
    function setParameterRef($key, &$value)
    {
        $this->_params[$key] =& $value;
    }

    /**
     * POST/GETֵͤ(ֵ)
     *
     * @param   string  $key    ѥ᡼̾
     * @return  string  ѥ᡼()
     * @access  public
     * @since   3.0.0
     */
    function getParameters()
    {
        return $this->_params;
    }

    /**
     * ڤʬ
     *
     * եsubmitܥ2ĤäƤ櫓
     * ڤʬ
     * <input type="submit" name="dispatch_A_B_C_D" value="OK">
     *    action  A_B_C_D ˤ꤫
     * <input type="submit" name="dispatch_E_F_G_H" value="OK">
     *    action  E_F_G_H ˤ꤫
     *
     * @access  public
     * @since   3.0.0
     */
    function dispatchAction()
    {
        $params = $this->getParameters();

        if (count($params) < 1) {
            return;
        }

        foreach ($params as $key => $value) {
            if (preg_match("/^dispatch_/", $key)) {
                $action = preg_replace("/^dispatch_/", "", $key);
                $action = preg_replace("/_x$/", "", $action);
                $action = preg_replace("/_y$/", "", $action);
                $this->setParameter(ACTION_KEY, $action);
                break;
            }
        }
    }
}
?>
