<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Smarty4Maple.class.php,v 1.9 2006/02/12 14:28:42 kunit Exp $
 */

require_once SMARTY_DIR . "/Smarty.class.php";
require_once 'core/BeanUtils.class.php';

/**
 * Smarty饹ĥƻѤ
 *
 * @package     Maple.smarty
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class Smarty4Maple extends Smarty
{
    var $template_dir;
    var $compile_dir;
    var $config_dir;
    var $cache_dir;
    var $caching;
    var $cache_lifetime;
    var $compile_check;
    var $force_compile;

    /**
     * 󥹥ȥ饯
     *
     * Smarty4Maple饹SingletonȤƻȤΤľnewƤϤʤ
     *
     * @access  private
     * @since   3.0.0
     */
    function Smarty4Maple()
    {
        $this->Smarty();

        $this->template_dir      = SMARTY_TEMPLATE_DIR;
        $this->compile_dir       = SMARTY_COMPILE_DIR;
        $this->config_dir        = SMARTY_CONFIG_DIR;
        $this->cache_dir         = SMARTY_CACHE_DIR;
        $this->caching           = SMARTY_CACHING;
        $this->cache_lifetime    = SMARTY_CACHE_LIFETIME;
        $this->compile_check     = SMARTY_COMPILE_CHECK;
        $this->force_compile     = SMARTY_FORCE_COMPILE;
        $this->default_modifiers = array(SMARTY_DEFAULT_MODIFIERS);

        if (TEMPLATE_CODE != INTERNAL_CODE) {
            // ץե륿Ͽ
            $this->register_prefilter('smarty4maple_prefilter');
        }
        if (OUTPUT_CODE != INTERNAL_CODE) {
            // ȥץåȥե륿Ͽ
            $this->register_outputfilter('smarty4maple_outputfilter');
        }
    }

    /**
     * Smarty4Maple饹ͣΥ󥹥󥹤ֵ
     *
     * @return  Object  Smarty4Maple饹Υ󥹥
     * @access  public
     * @since   3.0.0
     */
    function &getInstance()
    {
        static $instance;
        if ($instance === NULL) {
            $instance = new Smarty4Maple();
        }
        return $instance;
    }

    /**
     * ѥǥ쥯ȥȤ˴
     *
     * @access  public
     * @since   3.0.0
     */
    function clearTemplates_c()
    {
        $result = $this->clear_compiled_tpl();

        if ($result) {
            echo "Clear";
        } else {
            echo "NG";
        }

        return true;
    }

    /**
     * ƥץ졼ȤΥå˴
     *
     * @param   string  $tpl    ƥץ졼̾
     * @access  public
     * @since   3.0.0
     */
    function clearCache($tpl = "")
    {
        $result = $this->clear_cache($tpl);

        if ($result) {
            echo "Cache Clear";
        } else {
            echo "NG";
        }

        return true;
    }

    /**
     * Action򥻥åȤ
     *
     * @param   Object  $action ActionΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function setAction(&$action)
    {
        $this->register_object("action", $action);

        //
        // default_modifiersescapeäƤ뤫å
        //
        $needOfEscape = true;
        foreach ($this->default_modifiers as $modifier) {
            if (preg_match('|escape|', $modifier)) {
                $needOfEscape = false;
                break;
            }
        }

        //
        // ץѥƥΤ
        //
        $attributes = array();
        $util =& new BeanUtils;
        $util->toArray(get_object_vars($action), $attributes, $action, $needOfEscape);

        $this->assign('action', $attributes);
    }

    /**
     * ErrorList򥻥åȤ
     *
     * @param   Object  $errorList  ErrorListΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function setErrorList(&$errorList)
    {
        $this->register_object("errorList", $errorList);
    }

    /**
     * Token򥻥åȤ
     *
     * @param   Object  $token  TokenΥ󥹥
     * @access  public
     * @since   3.0.0
     */
    function setToken(&$token)
    {
        $this->register_object("token", $token);

        $this->assign('token', array(
            'name'  => $token->getName(),
            'value' => $token->getValue(),
        ));
    }

    /**
     * Session򥻥åȤ
     *
     * @param   Object  $session    SessionΥ󥹥
     * @access  public
     * @since   3.0.1
     */
    function setSession(&$session)
    {
        $this->register_object("session", $session);
    }

    /**
     * ScriptName򥻥åȤ
     *
     * @param   string  $scriptName ScriptName
     * @access  public
     * @since   3.1.0
     */
    function setScriptName($scriptName)
    {
        $this->assign('scriptName', $scriptName);
    }
}

/**
 * ץե륿
 */
function smarty4maple_prefilter($source, &$Smarty)
{
    return mb_convert_encoding($source, INTERNAL_CODE, TEMPLATE_CODE);
}

/**
 * ݥȥե륿
 */
function smarty4maple_postfilter($source, &$Smarty)
{
    return mb_convert_encoding($source, OUTPUT_CODE, INTERNAL_CODE);
}

/**
 * ȥץåȥե륿
 */
function smarty4maple_outputfilter($source, &$Smarty)
{
    return mb_convert_encoding($source, OUTPUT_CODE, INTERNAL_CODE);
}
?>
