<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      Hawk <w3l_admin@hawk.34sp.com>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: maple.inc.php,v 1.9 2006/02/12 14:28:42 kunit Exp $
 */

//
// mapleФƼ
//
if (!defined('DEBUG_MODE')) {
    define('DEBUG_MODE', 1);
}

if (!defined('BASE_DIR')) {
	define('BASE_DIR', dirname(dirname(dirname(__FILE__))));
}

define('MAPLE_DIR',  BASE_DIR . '/maple');
define('WEBAPP_DIR', BASE_DIR . '/webapp');

define('FILTER_DIR',    MAPLE_DIR . '/filter');
define('CONVERTER_DIR', MAPLE_DIR . '/converter');
define('VALIDATOR_DIR', MAPLE_DIR . '/validator');
define('LOGGER_DIR',    MAPLE_DIR . '/logger');

define('MODULE_DIR',    WEBAPP_DIR . '/modules');
define('LOG_DIR',       WEBAPP_DIR . '/logs');
define('COMPONENT_DIR', WEBAPP_DIR . '/components');

define('VALIDATE_ERROR_TYPE', 'input');
define('TOKEN_ERROR_TYPE', 'invalidToken');
define('UPLOAD_ERROR_TYPE', 'upload');

define('LEVEL_FATAL', 6);
define('LEVEL_ERROR', 5);
define('LEVEL_WARN',  4);
define('LEVEL_INFO',  3);
define('LEVEL_DEBUG', 2);
define('LEVEL_TRACE', 1);

define('DEFAULT_LOGGER', 'simpleFile');

define('INPUT_CODE',    'EUC-JP');
define('CONFIG_CODE',   'EUC-JP');
define('TEMPLATE_CODE', 'EUC-JP');
define('INTERNAL_CODE', 'EUC-JP');
define('OUTPUT_CODE',   'EUC-JP');
define('SCRIPT_CODE',   'EUC-JP');
define('SKELETON_CODE', 'EUC-JP');

//
// simple generator ǤɤΥƥץ졼ȤѤ뤫
//
define('DEFAULT_TEMPLATE', 'simple');

//
// SimpleViewϢΥǥ쥯ȥ
// ()ǥ쥯ȥǤκǸˡ/פĤ뤳
//
define('TEMPLATE_DIR', WEBAPP_DIR . '/templates/');

//
// SmartyϢΥǥ쥯ȥ
// ()ǥ쥯ȥǤκǸˡ/פĤ뤳
//
define('SMARTY_DIR',               MAPLE_DIR  . '/smarty/');
define('SMARTY_TEMPLATE_DIR',      WEBAPP_DIR . '/templates/');
define('SMARTY_COMPILE_DIR',       WEBAPP_DIR . '/templates_c/');
define('SMARTY_CONFIG_DIR',        WEBAPP_DIR . '/config/');
define('SMARTY_CACHE_DIR',         WEBAPP_DIR . '/cache/');
define('SMARTY_CACHING',           false);
define('SMARTY_CACHE_LIFETIME',    3600);
define('SMARTY_COMPILE_CHECK',     false);
define('SMARTY_FORCE_COMPILE',     true);
define('SMARTY_DEFAULT_MODIFIERS', 'escape:"html"');
//define('SMARTY_DEFAULT_MODIFIERS', ''); // SmartyǼưescapeʤ

//
// FlexyϢΥǥ쥯ȥ
// ()ǥ쥯ȥǤκǸˡ/פĤ뤳
//
// FlexyϢ¾ˤѤǤ뤬
// ¿Υץꤹ
// Flexy_Flexy4Maple::globalOptions
// Ѥɤ
//
define('FLEXY_TEMPLATE_DIR', WEBAPP_DIR .'/templates/');
define('FLEXY_COMPILE_DIR',  WEBAPP_DIR .'/templates_c/');

/*
require_once(MAPLE_DIR .'/flexy/Flexy_Flexy4Maple.class.php');

Flexy_Flexy4Maple::globalOptions(
   "allowPHP" => false,
   "globals"  => true,
   "debug"    => true
);
*/

if (!defined('PATH_SEPARATOR')) {
	if (strtoupper(substr(PHP_OS, 0, 3)) === 'WIN') {
		define('PATH_SEPARATOR', ';');
	} else {
		define('PATH_SEPARATOR', ':');
	}
}

ini_set('include_path', MAPLE_DIR . PATH_SEPARATOR . ini_get('include_path'));

//
// ControllerǻѤƥ饹ե
//
define('BASE_INI', WEBAPP_DIR . '/config/base.ini');

//
// Controllerɹ
//
require_once 'core/Controller.class.php';
?>
