<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.filter
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Filter_Action.class.php,v 1.6 2006/02/11 19:18:22 kunit Exp $
 */

require_once 'core/BeanUtils.class.php';

/**
 * Actionμ¹ԽӼ¹ԤԤFilter
 *
 * @package     Maple.filter
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.0.0
 */
class Filter_Action extends Filter
{
    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.0.0
     */
    function Filter_Action()
    {
        parent::Filter();
    }

    /**
     * Action¹
     *
     * @access  public
     * @since   3.0.0
     */
    function execute()
    {
        $log =& LogFactory::getLog();
        $log->trace("Filter_Action¹Ԥޤ", "Filter_Action#execute");

        //
        // ȤAction
        //
        $container =& DIContainerFactory::getContainer();
        $actionChain =& $container->getComponent("ActionChain");
        $action =& $actionChain->getCurAction();

        //
        // եäƤͤ
        //
        $request =& $container->getComponent("Request");
        $params = $request->getParameters();

        if ($this->getSize() > 0) {
            $attributes = $this->getAttributes();
            foreach ($attributes as $key => $value) {
                if (preg_match("/^ref:/", $value)) {
                    $value = preg_replace("/^ref:/", "", $value);
                    $component =& $container->getComponent($value);
                    if (is_object($component)) {
                        $attributes[$key] =& $component;
                    } else {
                        $log->error("ʥݡͥȤեǻꤵƤޤ($value)", "Filter_Action#execute");
                    }
                }

                //
                // DIѥ᡼ϥꥯȥѥ᡼
                // 񤭤ʤ褦ˤ
                //
                if (isset($params[$key])) {
                    unset($params[$key]);
                }
            }
            BeanUtils::setAttributes($action, $attributes);
        }

        //
        // RequestͤAction˰ܤ
        //
        if (count($params) > 0) {
            BeanUtils::setAttributes($action, $params, true);
        }

        //
        // Filter_ActionˤɤĤ˥顼ȯƤ
        // Actionϼ¹ԤʤʤΤꥨ顼פViewμȤ
        //
        $errorList =& $actionChain->getCurErrorList();
        $type = $errorList->getType();

        if ($type == "") {
            $view = $actionChain->execute();
        } else {
            $view = $type;
        }

        if ($view != "") {
            $response =& $container->getComponent("Response");
            $response->setView($view);
        }

        $filterChain =& $container->getComponent("FilterChain");
        $filterChain->execute();

        $log->trace("Filter_Actionθ¹Ԥޤ", "Filter_Action#execute");
    }
}
?>
