<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.filter
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Filter_Debug.class.php,v 1.4 2006/02/12 16:36:18 kunit Exp $
 */

/**
 * ǥХåɽFilter
 *
 * @package     Maple.filter
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Filter_Debug extends Filter
{
    /** @var array ɽ  */
    var $_debugs = array();

    var $_debug_pool = array();

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.1.0
     */
    function Filter_Debug()
    {
        parent::Filter();
    }

    /**
     * ǥХåɽ
     *
     * @access  public
     * @since   3.1.0
     */
    function execute()
    {
        $log =& LogFactory::getLog();
        $log->trace("Filter_Debug¹Ԥޤ", "Filter_Debug#execute");
        $this->_preFilter();
        
        $container =& DIContainerFactory::getContainer();
        $filterChain =& $container->getComponent("FilterChain");
        $filterChain->execute();

        $log->trace("Filter_Debugθ¹Ԥޤ", "Filter_Debug#execute");
        $this->_postFilter();

    }
    
    /**
     * ץե륿
     */
    function _preFilter()
    {
        // ⤷ʤ
    }
    
    /**
     * ݥȥե륿
     */
    function _postFilter()
    {
        $NO = 'ʤ';
        if (OUTPUT_CODE != INTERNAL_CODE) {
            $NO = mb_convert_encoding($NO, OUTPUT_CODE, INTERNAL_CODE);
        }
        $var = (isset($_POST) && (0 < count($_POST)))? $_POST: $NO;
        $this->addParam('ꥯȥѥ᡼($_POST)', $var);

        $var = (isset($_GET) && (0 < count($_GET)))? $_GET: $NO;
        $this->addParam('ꥯȥѥ᡼($_GET)', $var);

        $var = (isset($_FILES) && (0 < count($_FILES)))? $_FILES: $NO;
        $this->addParam('ꥯȥѥ᡼($_FILES)', $var);

        $var = (isset($_SESSION) && (0 < count($_SESSION)))? $_SESSION: $NO;
        $this->addParam('ꥯȥѥ᡼($_SESSION)', $var);

        $container =& DIContainerFactory::getContainer();

        $actionChain =& $container->getComponent("ActionChain");
        foreach ($actionChain->_list as $name => $action) {
            $this->addParam("({$name})", $action);
            $this->addParam("顼ꥹ({$name})", $actionChain->_errorList[$name]);
        }

        $this->rejectRecursion($container->_components, $result);
        $this->addParam("DIContainer", $result);

        $this->_printDebug();
    }

    /**
     * Ϥ줿Фƽ۴ĻȤ
     * 
     * @param array $values оݤȤʤ
     * @param array $result 
     */
    function rejectRecursion(&$values, &$result)
    {
        foreach ($values as $key => $value) {
            if (in_array($key, array('_debugs', '_debug_pool'), true)) {
                if (is_object($result)) {
                    unset($result->$key);
                } else {
                    unset($result[$key]);
                }
                continue;
            } else if (is_object($value)) {
                $class = get_class($value);
                if (array_key_exists($class, $this->_debug_pool)) {
                    if (array_key_exists($key, $this->_debug_pool[$class])) {
                        if (is_object($result)) {
                            unset($result->$key);
                        } else {
                            unset($result[$key]);
                        }
                        continue;
                    }
                }
                $this->_debug_pool[$class][$key] = $key;
                $vars = get_object_vars($value);
                if (version_compare(phpversion(), '5.0.0', '>=') == 1) {
                    eval('$obj = clone $value;');
                } else {
                    $obj = $value;
                }
                if (is_object($result)) {
                    $result->$key = $obj;
                    $this->rejectRecursion($vars, $result->$key);
                } else {
                    $result[$key] = $obj;
                    $this->rejectRecursion($vars, $result[$key]);
                }
            } else if (is_array($value)) {
                if (is_object($result)) {
                    $result->$key = array();
                    $this->rejectRecursion($value, $result->$key);
                } else {
                    $result[$key] = array();
                    $this->rejectRecursion($value, $result[$key]);
                }
            } else {
                if (is_object($result)) {
                    $result->$key = $value;
                } else {
                    $result[$key] = $value;
                }
            }
        }
    }

    /**
     * ǥХåɲä
     * 
     * @param string $title ȥ
     * @param mixed $var ǥХåоݤѿ
     */
    function addParam($title, $var)
    {
        if (OUTPUT_CODE != INTERNAL_CODE) {
            $title = mb_convert_encoding($title, OUTPUT_CODE, INTERNAL_CODE);
        }
        $this->_debugs[$title] = $var;
    }
    
    /**
     * JavascriptѤΥ׽
     * 
     * @param string $src javascript
     */
    function _escapeJavascript($src)
    {
        return strtr($src, array('\\'=>'\\\\',"'"=>"\\'",'"'=>'\\"',"\r"=>'\\r',"\n"=>'\\n','</'=>'<\/'));
    }
    
    /**
     * ǥХåɽ
     */
    function _printDebug()
    {
        ob_start();
        require_once 'dBug/dBug.php';
        new dBug($this->_debugs, 'array');
        $debug = ob_get_contents();
        ob_end_clean();

        // ɽHTMLκ
        $html = <<<HTML
<HTML>
<HEAD>
<TITLE>Maple Debug Console</TITLE>
</HEAD>
<BODY bgcolor=#ffffff>
<table border=0 width=100%><tr bgcolor=#cccccc><th colspan=2>Maple Debug Console</th></tr></table>
{$debug}
</BODY>
</HTML>
HTML;

        // JavascriptѤ˥׽
        $html = $this->_escapeJavascript($html);

        // Javascript
        $JS = <<<JS
<SCRIPT language=javascript>
    var title = 'Console';
    _smarty_console = window.open("",title.value,"width=680,height=600,resizable,scrollbars=yes");
    _smarty_console.document.write("$html");
    _smarty_console.document.close();
</SCRIPT>
JS;
        print $JS;
    }
}

?>
