<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.filter
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Filter_SimpleView.class.php,v 1.3 2006/02/12 14:28:42 kunit Exp $
 */

require_once 'core/BeanUtils.class.php';

/**
 * PHPincludeѤViewμ¹ԤԤFilter
 *
 * @package     Maple.filter
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Filter_SimpleView extends Filter
{
    var $_classname = "Filter_SimpleView";

    var $_container;
    var $_log;
    var $_filterChain;
    var $_response;
    var $_actionChain;
    var $_token;
    var $_session;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.1.0
     */
    function Filter_SimpleView()
    {
        parent::Filter();
   }

    /**
     * Viewν¹
     *
     * @access  public
     * @since   3.1.0
     */
    function execute()
    {
        $this->_container   =& DIContainerFactory::getContainer();
        $this->_log         =& LogFactory::getLog();
        $this->_filterChain =& $this->_container->getComponent("FilterChain");
        $this->_response    =& $this->_container->getComponent("Response");
        $this->_actionChain =& $this->_container->getComponent("ActionChain");
        $this->_token       =& $this->_container->getComponent("Token");
        $this->_session     =& $this->_container->getComponent("Session");
 
        $this->_log->trace("{$this->_classname}¹Ԥޤ", "{$this->_classname}#execute");
        $this->_preFilter();
        
        $this->_filterChain->execute();

        $this->_log->trace("{$this->_classname}θ¹Ԥޤ", "{$this->_classname}#execute");
        $this->_postFilter();
    }
    
    /**
     * ץե륿
     *
     * @access  private
     * @since   3.1.0
     */
    function _preFilter()
    {
        // ⤷ޤ
    }    
    
    /**
     * ݥȥե륿
     *
     * @access  private
     * @since   3.1.0
     */
    function _postFilter()
    {
        $view = $this->_response->getView();

        if ($view != "") {
            $template = $this->getAttribute($view);
            if ($template == "") {
                $this->_log->error("ƥץ졼ȥեμ˼Ԥޤ", "{$this->_classname}#execute");
                exit;
            }

            if (preg_match("/location:/", $template)) {
                $url = preg_replace("/location:/", "", $template);
                $url = trim($url);
                $this->_response->setRedirect($url);
            } else {
                $action    =& $this->_actionChain->getCurAction();
                $errorList =& $this->_actionChain->getCurErrorList();
                $token     =& $this->_token;
                $session   =& $this->_session;

                $h = array();
                $util =& new BeanUtils;
                $util->toArray(get_object_vars($action), $h, $action);

                $scriptName = $_SERVER['SCRIPT_NAME'];

                $template = TEMPLATE_DIR . $template;
                if (!file_exists($template)) {
                    $this->_log->error("$template¸ߤޤ", "{$this->_classname}#execute");
                    exit;
                }
                
                ob_start();
                include_once($template);
                $result = ob_get_contents();
                ob_end_clean();
                
                if (OUTPUT_CODE != INTERNAL_CODE) {
                    $result = mb_convert_encoding($result, OUTPUT_CODE, INTERNAL_CODE);
                }

                if ($result != "") {
                    $this->_response->setResult($result);
                }
            }
        }

        $contentDisposition = $this->_response->getContentDisposition();
        $contentType        = $this->_response->getContentType();
        $result             = $this->_response->getResult();
        $redirect           = $this->_response->getRedirect();

        if ($redirect) {
            header("Location: ${redirect}");
        } else {
            if ($contentDisposition != "") {
                header("Content-disposition: ${contentDisposition}");
            }
            if ($contentType != "") {
                header("Content-type: ${contentType}");
            }

            print $result;
        }
    }
}

/**
 * htmlspecialcharsΥץؿ
 *
 * @package     Maple.simple
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
function h($str)
{
    return htmlspecialchars($str, ENT_QUOTES);
}

?>
