<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Generate_GetOpt.class.php,v 1.3 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * ޥɥ饤Ǽ
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Generate_GetOpt
{
    /**
     * @var ޥɥ饤ݻ
     *
     * @access  private
     * @since   3.1.0
     */
    var $_params;

    /**
     * 󥹥ȥ饯
     *
     * @access  public
     * @since   3.1.0
     */
    function Generate_GetOpt()
    {
        $this->_params = array();
        if (php_sapi_name() != 'cli') {
            return;
        }

        if (isset($_SERVER['argv'])) {
            $this->_params['args'] = $_SERVER['argv'];
            $script    = array_shift($this->_params['args']);
            $generator = array_shift($this->_params['args']);
            if ($generator) {
                $this->_params[ACTION_KEY] = 'maple_generate_generators_' . $generator;
            } else {
                $this->_params[ACTION_KEY] = 'maple_generate_usage';
            }
        } else {
            $this->_params['args'] = array();
        }
    }

    /**
     * PHPμ¹ԥ󥿥եֵ
     *
     * @return  string  PHPμ¹ԥ󥿥ե
     * @access  public
     * @since   3.1.0
     */
    function getMethod()
    {
        return php_sapi_name();
    }

    /**
     * ֵͤ
     *
     * @param   string  $key    ѥ᡼̾
     * @return  string  ѥ᡼
     * @access  public
     * @since   3.1.0
     */
    function getParameter($key)
    {
        if (isset($this->_params[$key])) {
            return $this->_params[$key];
        }
    }

    /**
     * ֵͤ(֥Ȥֵ)
     *
     * @param   string  $key    ѥ᡼̾
     * @return  Object  ѥ᡼
     * @access  public
     * @since   3.1.0
     */
    function &getParameterRef($key)
    {
        if (isset($this->_params[$key])) {
            return $this->_params[$key];
        }
    }

    /**
     * ͤ򥻥å
     *
     * @param   string  $key    ѥ᡼̾
     * @param   string  $value  ѥ᡼
     * @access  public
     * @since   3.1.0
     */
    function setParameter($key, $value)
    {
        $this->_params[$key] = $value;
    }

    /**
     * ͤ򥻥å(֥Ȥ򥻥å)
     *
     * @param   string  $key    ѥ᡼̾
     * @param   Object  $value  ѥ᡼
     * @access  public
     * @since   3.1.0
     */
    function setParameterRef($key, &$value)
    {
        $this->_params[$key] =& $value;
    }

    /**
     * ֵͤ(ֵ)
     *
     * @param   string  $key    ѥ᡼̾
     * @return  string  ѥ᡼()
     * @access  public
     * @since   3.1.0
     */
    function getParameters()
    {
        return $this->_params;
    }

    /**
     * ڤʬ
     *
     * Υ饹Ǥϲʤ
     *
     * @access    public
     * @since    3.1.0
     */
    function dispatchAction()
    {
        return;
    }
}
?>
