<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Filter.class.php,v 1.1 2006/02/12 14:28:42 kunit Exp $
 */

/**
 * Filterե
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Maple_Generate_Creator_Filter
{
    var $fileUtil;

    /**
     * Filterե
     *
     * @params  string  $filterName  filter̾
     * @access  public
     * @since   3.1.0
     */
    function create($filterName)
    {
        $classname = "Filter_" . ucfirst($filterName);
        $filename  = FILTER_DIR . "/${classname}.class.php";

        if (!preg_match("/^[0-9a-zA-Z.]+$/", $filterName)) {
            return array(
                $filename => 'error',
            );
        }

        $result = array();
        if (@file_exists($filename)) {
            $result[$filename] = 'exists';
        } else {
            $skeleton = new StdClass;
            $skeleton->classname = $classname;

            ob_start();
            include_once(TEMPLATE_DIR . 'maple/generate/skeleton/filter.txt');
            $buf = ob_get_contents();
            ob_end_clean();

            if (SCRIPT_CODE != SKELETON_CODE) {
                $buf = mb_convert_encoding($buf, SCRIPT_CODE, SKELETON_CODE);
            }

            $buf = str_replace("\r\n", "\n", $buf);

            if ($this->fileUtil->write($filename, $buf)) {
                $result[$filename] = 'create';
            } else {
                $result[$filename] = 'fail';
            }
        }

        return $result;
    }
}
?>
