<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Template.class.php,v 1.2 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * Templateե
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Maple_Generate_Creator_Template
{
    var $fileUtil;
    var $container;
    var $actionChain;

    /**
     * ե
     *
     * @params  string  $templateType   ƥץ졼ȥ󥸥Υ
     * @params  string  $templateName   template̾
     * @access  public
     * @since   3.1.0
     */
    function create($templateType, $templateName)
    {
        $templateType = ucfirst(strtolower($templateType));

        $componentName = "maple.generate.creator.templateType.${templateType}";
        list ($className, $classFile) = $this->container->makeNames($componentName);

        $error = false;
        if (!@file_exists($classFile)) {
            $componentName = "maple.generate.creator.templateType.simple";
            list ($className, $classFile) = $this->container->makeNames($componentName);
            $error = true;
        }

        include_once($classFile);
        $instance =& new $className();

        $dir = null;
        if (is_object($instance)) {
            $settings = $instance->getSettings();
            $dir = $settings['dir'];
        } else {
            $dir = WEBAPP_DIR . "/templates/";
        }

        $filename = $dir . str_replace('_', '/', $templateName) . '.html';

        if ($error) {
            return array(
                $filename => 'error',
            );
        } else if (!preg_match("/^[0-9a-zA-Z_]+$/", $templateName)) {
            return array(
                $filename => 'error',
            );
        }

        $result = array();
        if (@file_exists($filename)) {
            $result[$filename] = 'exists';
        } else {
            ob_start();
            include_once(TEMPLATE_DIR . 'maple/generate/skeleton/template.txt');
            $buf = ob_get_contents();
            ob_end_clean();

            if (TEMPLATE_CODE != SKELETON_CODE) {
                $buf = mb_convert_encoding($buf, TEMPLATE_CODE, SKELETON_CODE);
            }

            $buf = str_replace("\r\n", "\n", $buf);

            if ($this->fileUtil->write($filename, $buf)) {
                $result[$filename] = 'create';
            } else {
                $result[$filename] = 'fail';
            }
        }

        return $result;
    }
}
?>
