<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Action.class.php,v 1.2 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * action generatorΥå
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Maple_Generate_Logic_Action
{
    var $actionCreator;
    var $configCreator;
    var $templateCreator;
    var $entryCreator;

    /**
     * action generatorΥå¹Ԥ
     *
     * @params  object  $dto    DTO饹Υ󥹥
     * @access  public
     * @since   3.1.0
     */
    function execute(&$dto)
    {
        $actionName   = $dto->actionName;
        $templateType = $dto->templateType;
        $templateName = $dto->templateName;
        $entryName    = $dto->entryName;

        $fileList = array();
        $fileList += $this->actionCreator->create($actionName);

        if (!$templateType) {
            return $fileList;
        }

        $fileList += $this->configCreator->create($actionName, $templateType, $templateName);
        $fileList += $this->templateCreator->create($templateType, $templateName);

        if (!$entryName) {
            return $fileList;
        }

        $fileList += $this->entryCreator->create($entryName, $actionName);

        return $fileList;
    }
}
?>
