<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: File.class.php,v 1.2 2006/02/11 19:18:22 kunit Exp $
 */

/**
 * ǥ쥯ȥꡦե饹
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Maple_Generate_Util_File
{
    /**
     * եɤ߹
     *
     * եɤ߹ǰĤʸȤ֤
     *
     * @param string $fileName  ե̾
     * @return string  ե
     * @access public
     */
    function read($fileName)
    {
        $buf = '';
        $realPath = realpath($fileName);
        if (file_exists($realPath)) {
            if (function_exists('file_get_contents')) {
                $buf = file_get_contents($realPath);
            } else {
                $fh = fopen($fileName, "rb");
                $buf = fread($fh, filesize($fileName));
                fclose($fh); 
            }
        }
        return $buf;
    }

    /**
     * եɵ
     *
     * ꤷƤեɵǽ񤭹ࡣ
     * Υե¸ߤʤϼưŪ˺롣
     *
     * @param string $fileName  ե̾
     * @param string $buf  񤭹
     * @return boolean
     * @access public
     */
    function append($fileName, $buf)
    {
        return Maple_Generate_Util_File::write($fileName, $buf, "ab");
    }

    /**
     * ե˽񤭹
     *
     * ꤷƤե˾񤭤ǽ񤭹ࡣ
     * Υե¸ߤʤϼưŪ˺롣
     *
     * @param string $fileName  ե̾
     * @param string $buf  񤭹
     * @param string $mode  񤭹ߥ⡼
     * @return boolean
     * @access public
     */
    function write($fileName, $buf, $mode = "wb")
    {
        Maple_Generate_Util_File::makeDir(dirname($fileName));
        
        if (!($fh = fopen($fileName, $mode))) {
            return false;
        }
        if (!fwrite($fh, $buf)) {
            return false;
        }
        if (!fclose($fh)) {
            return false;
        }
        return true;
    }

    /**
     * ǥ쥯ȥ롣
     * 
     * ʣؤΥǥ쥯ȥꤷˡ
     * Υǥ쥯ȥ⼫ưŪ˺롣
     * 
     * @param mixed $dirNames  ǥ쥯ȥ̾ޤϤ
     * @access public
     */
    function makeDir($dirNames)
    {
        if (!is_array($dirNames)) {
            $dirNames = array($dirNames);
        }
        
        foreach($dirNames as $dir){
            Maple_Generate_Util_File::_makeDir($dir);
        }
    }

    /**
     * ǥ쥯ȥ
     *
     * ꤷǥ쥯ȥ겼Υǥ쥯ȥꡦե
     * ưŪ˺롣
     *
     * @param mixed $dirNames  ǥ쥯ȥ̾ޤϤ
     * @access public
     */
    function removeDir($dirNames)
    {
        if (!is_array($dirNames)) {
            $dirNames = array($dirNames);
        }
        
        foreach($dirNames as $dir){
            Maple_Generate_Util_File::_removeDir($dir);
        }
    }

    /**
     * ǥ쥯ȥȥեΥꥹȤ
     *
     * ͤǡǽ餬ǥ쥯ȥ󡢼˥եȤʤ롣
     * list($dirs, $files) = Maple_Generate_Util_File::ls($dirname);
     *
     * @param string $dirName  ǥ쥯ȥ̾
     * @return array  ǥ쥯ȥȥե
     * @access public
     */
    function ls($dirName)
    {
        $realPath = realpath($dirName);
        if (!$dh = opendir($realPath)) {
            return false;
        }

        $dirs = $files = array();
        while (($file = readdir($dh)) !== false) {
            if (preg_match("/^[.]{1,2}$/", $file)) {
                continue;
            }
            $fullPath = Maple_Generate_Util_File::_addTail($realPath, DIRECTORY_SEPARATOR).$file;
            if (is_dir($fullPath)) {
                $dirs[] = $fullPath;
            } else {
                $files[] = $fullPath;
            }
        }
        closedir($dh);
        return array($dirs, $files);
    }

    /**
     * ꤷǥ쥯ȥΥեꥹȤ
     *
     * @param string $dirName  ǥ쥯ȥ̾
     * @param string [$regex]  ե̾ɽ
     * @return array  ե
     * @access public
     */
    function find($dirName, $regex = "")
    {
        $data = Maple_Generate_Util_File::ls($dirName);
        if (!is_array($data)) {
            return array();
        }
        list($dirs, $files) = $data;

        if ($regex == "") {
            return $files;
        }
        $found = array();
        foreach ($files as $file) {
            if (preg_match($regex, basename($file))) {
                $found[] = $file;
            }
        }
        return $found;
    }

    /**
     * ꤷǥ쥯ȥΥեꥹȤ
     * 
     * ֥ǥ쥯ȥ꤬ϺƵŪ˼
     *
     * @param string $dirName  ǥ쥯ȥ̾
     * @param string [$regex]  ե̾ɽ
     * @return array  ե
     * @access public
     */
    function findRecursive($dirName, $regex = "")
    {
        $data = Maple_Generate_Util_File::ls($dirName);
        if (!is_array($data)) {
            return array();
        }
        list($dirs, $files) = $data;
        
        $found = Maple_Generate_Util_File::find($dirName, $regex);

        foreach ($dirs as $dir) {
            $found = array_merge($found, Maple_Generate_Util_File::findRecursive($dir, $regex));
        }

        return $found;
    }

    /**
     * ǥ쥯ȥ롣
     *
     * ƥǥ쥯ȥ꤬ʤмưŪ˺롣
     *
     * @param string $dirName  ǥ쥯ȥ̾
     * @access private
     */
    function _makeDir($dirName)
    {
        if (DIRECTORY_SEPARATOR != "/") {
            $dirName = str_replace(DIRECTORY_SEPARATOR, "/", $dirName);
        }
        $dirNames = explode("/", $dirName);
        $makeDirName = realpath(array_shift($dirNames)).DIRECTORY_SEPARATOR;;
        foreach ($dirNames as $dir) {
            $makeDirName = $makeDirName.$dir.DIRECTORY_SEPARATOR;
            if (!file_exists($makeDirName)) {
                mkdir($makeDirName);
            }
        }
    }

    /**
     * ǥ쥯ȥ
     *
     * ֥ǥ쥯ȥ꤬мưŪ˺롣
     * ꤷǥ쥯ȥʲΥե⼫ưŪ˺롣
     *
     * @param string $dirName  ǥ쥯ȥ̾
     * @access private
     */
    function _removeDir($dirName)
    {
        $data = Maple_Generate_Util_File::ls($dirName);
        if (!is_array($data)) {
            return;
        }
        list($dirs, $files) = $data;
        
        if (is_dir($dirName)) {
            array_unshift($dirs, $dirName);
        }

        foreach($files as $file){
            if (file_exists($file)) {
                unlink($file);
            }
        }

        foreach(array_reverse($dirs) as $dir){
            if (file_exists($dir)) {
                rmdir($dir);
            }
        }
    }

    /**
     * ʸʸɲä
     *
     * ʸθɲäʸƱ
     * ⤷ޤ
     * 
     * @param string $target  ɲоݤʸ
     * @param string $add  ɲäʸ 
     * @return string Ѵʸ
     * @access private
     */
    function _addTail($target, $add)
    {
        $regex = preg_quote($add);
        if (!preg_match("|.*{$regex}$|", $target)) {
            $target = $target.$add;
        }
        return $target;
    }
}
?>
