<?php

/* vim: set expandtab tabstop=4 shiftwidth=4 softtabstop=4: */

/**
 * Maple - PHP Web Application Framework
 *
 * PHP versions 4 and 5
 *
 * LICENSE: This source file is subject to version 3.0 of the PHP license
 * that is available through the world-wide-web at the following URI:
 * http://www.php.net/license/3_0.txt.  If you did not receive a copy of
 * the PHP License and are unable to obtain it through the web, please
 * send a note to license@php.net so we can mail you a copy immediately.
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @author      Kazunobu Ichihashi <bobchin_ryu@bb.excite.co.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @version     CVS: $Id: Action.class.php,v 1.1 2006/02/11 19:18:23 kunit Exp $
 */

/**
 * ActionϢե
 *
 * @package     Maple.generate
 * @author      TAKAHASHI Kunihiko <kunit@kunit.jp>
 * @copyright   2004-2006 The Maple Project
 * @license     http://www.php.net/license/3_0.txt  PHP License 3.0
 * @access      public
 * @since       3.1.0
 */
class Maple_Generate_Generators_Action
{
    var $args;
    var $logic;

    var $_fileList;

    /**
     * ActionϢե
     *
     * @access  public
     * @since   3.1.0
     */
    function execute()
    {
        if (!isset($this->args) || !is_array($this->args) ||
            (count($this->args) == 0)) {
            return 'usage';
        }

        $dto = new StdClass;

        $dto->actionName = array_shift($this->args);
        if (count($this->args) > 0) {
            $dto->templateType = array_shift($this->args);
        } else {
            $dto->templateType = null;
        }
        if (count($this->args) > 0) {
            $dto->templateName = array_shift($this->args);
        } else {
            $dto->templateName = $dto->actionName;
        }
        if (count($this->args) > 0) {
            $dto->entryName = array_shift($this->args);
        } else {
            $dto->entryName = null;
        }

        $this->_fileList = $this->logic->execute($dto);

        return 'success';
    }

    /**
     * եꥹȤֵ
     *
     * @return  array   եꥹ
     * @access  public
     * @since   3.1.0
     */
    function getFileList()
    {
        return $this->_fileList;
    }
}
?>
